Index: trunk/examples/extended/electromagnetic/TestEm9/GNUmakefile
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/GNUmakefile	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/GNUmakefile	(revision 1337)
@@ -1,4 +1,4 @@
-# $Id: GNUmakefile,v 1.9 2008/06/11 22:31:05 maire Exp $
-# GEANT4 tag $Name: geant4-09-03-cand-01 $
+# $Id: GNUmakefile,v 1.10 2010/01/11 16:29:51 gcosmo Exp $
+# GEANT4 tag $Name: geant4-09-04-beta-01 $
 # --------------------------------------------------------------
 # GNUmakefile for examples module with AIDA interface
@@ -10,5 +10,5 @@
 
 ifndef G4INSTALL
-  G4INSTALL = ../../../../
+  G4INSTALL = ../../../..
 endif
 
Index: trunk/examples/extended/electromagnetic/TestEm9/History
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/History	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/History	(revision 1337)
@@ -1,3 +1,3 @@
-$Id: History,v 1.44 2007/11/13 14:44:26 vnivanch Exp $
+$Id: History,v 1.62 2010/06/07 05:40:46 perl Exp $
 -------------------------------------------------------------------
 
@@ -14,6 +14,62 @@
      ----------------------------------------------------------
      * Reverse chronological order (last date on top), please *
-
      ----------------------------------------------------------
+     
+06-06-10 J.Perl (testem9-V09-03-03)
+- Remove unused variable in EventAction
+
+03-06-10 J.Perl (testem9-V09-03-02)
+- Updated vis usage 
+
+21-05-10 mma (testem9-V09-03-01)     
+TestEm9.cc : introduction of G4UIExecutive
+
+29-04-10 V.Ivant (testem9-V09-03-00)
+- added a table of average number of calls of processes versus 
+  atomic number of an atom on which interaction takes place
+
+20-11-09 V.Ivant (testem9-V09-02-00)
+- use Livermore and Penelope builders from PhysList library
+     
+16-11-08 mma (testem9-V09-01-09)
+- Em options: 20bins/decade  LinLossLimit=default=0.01
+
+16-10-08 V.Ivant (testem9-V09-01-08)
+- Removed temporary builders PhysListEmStandardLPM and 
+PhysListEmStandardIG
+
+24-09-08 V.Ivant (testem9-V09-01-07)
+- added control on number of events with Edep < 80%
+- use double for number of steps instead of integer
+     
+22-09-08 mma
+- histo.cc : root format by default
+
+22-08-08 V.Ivant (testem9-V09-01-06)
+- added computation of ratios E9/E25
+- PhysList with relativistic LPM model is done on top of PhysList
+  option1 
+
+11-08-08 V.Ivant (testem9-V09-01-05)
+- added computation of ratios E1/E9 and E1/E25
+- added PhysLists with relativistic LPM model 
+- updated macro
+
+12-06-08 mma (testem9-V09-01-04)
+- Remove AIDA from GNUmakefile 
+     
+07-05-08 mma (testem9-V09-01-03)
+- PhysListEmStandard : add spline option for physics tables
+- README : update Aida informations
+     
+08-04-08 mma (testem9-V09-01-02)
+- PhysListEmStandard : replace G4MultipleScattering by G4eMultipleScattering. 
+                       Complete EmOptions
+
+07-04-08 V.Ivant (testem9-V09-01-01)
+- fixed problem of geometry/cut modification between runs 
+
+18-03-08 V.Ivant (testem9-V09-01-00)
+- added G4EmStandardPhyiscs_option3
 
 13-11-07 V.Ivant (testem9-V09-00-00)
Index: trunk/examples/extended/electromagnetic/TestEm9/README
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/README	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/README	(revision 1337)
@@ -1,3 +1,3 @@
-$Id: README,v 1.10 2006/11/22 18:58:25 vnivanch Exp $
+$Id: README,v 1.12 2008/08/22 14:35:12 vnivanch Exp $
 -------------------------------------------------------------------
 
@@ -45,11 +45,17 @@
     4. StepMax - for steplimitation
 
-    The following options for EM physics are available:	 
-    - "standard"        the best standard EM physics (default)
-    - "G4standard"      recommended standard EM physics for LHC
-    - "G4standard_fast" the best CPU performance standard physics for LHC
-    - "G4standard_exp"  experimental standard physics for LHC
-    - "Livermore"       low-energy EM physics using Livermore data
-    - "Penelope"        low-energy EM physics implementing Penelope models
+    The following options for EM physics using builders from physics_lists
+    sub-package are available:	 
+    - "emstandard"        (default)
+    - "emstandard_opt1"   (EMV)
+    - "emstandard_opt2"   (EMX)
+    - "emstandard_opt3"   recommended for medical and space applications
+
+    There are local to this example variants of EM physics: 
+    - "emstandard_local"   close to opt3
+    - "standardIG"         close to opt2
+    - "standardLPM"        relativistic bremsstrahlung model added to opt1  
+    - "Livermore"          low-energy EM physics using Livermore data
+    - "Penelope"           low-energy EM physics implementing Penelope models
 
     Optional components can be added:
@@ -105,36 +111,8 @@
  ------------------- 
 
-By default the histograms are not activated. To activate histograms
-the environment variable G4ANALYSIS_USE should be defined. For instance
-uncomment the flag G4ANALYSIS_USE in GNUmakefile.
+     By default the histograms are not activated. To activate histograms
+     the environment variable G4ANALYSIS_USE should be defined. For instance
+     uncomment the flag G4ANALYSIS_USE in GNUmakefile.
 
-To use histograms any of implementations of AIDA interfaces should
-be available (see http://aida.freehep.org).
-
-A package including AIDA and extended interfaces also using Python
-is PI, available from: http://cern.ch/pi .
-
-Once installed PI or PI-Lite in a specified local area $MYPY, it is
-required to add the installation path to $PATH, i.e. for example,
-for release 1.2.1 of PI:
-
-setenv PATH ${PATH}:$MYPI/1.2.1/app/releases/PI/PI_1_2_1/rh73_gcc32/bin
-
-CERN users can use the PATH to the LCG area on AFS.
-
-Before compilation of the example it is optimal to clean up old 
-files:
-
-gmake histclean
-gmake
-
-Before running the example the command should be issued:
-
-eval `aida-config --runtime csh`
-
-It is possible to choose the format of the output file with 
-histograms using UI command:
-
-/testem/histo/setFileType type
-
-The following types are available: hbook, root, xml.
+     To use histograms any of implementations of AIDA interfaces should
+     be available. See InstallAida.txt
Index: trunk/examples/extended/electromagnetic/TestEm9/TestEm9.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/TestEm9.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/TestEm9.cc	(revision 1337)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: TestEm9.cc,v 1.8 2006/11/17 17:45:05 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: TestEm9.cc,v 1.10 2010/05/21 18:32:34 maire Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -33,6 +33,4 @@
 #include "G4RunManager.hh"
 #include "G4UImanager.hh"
-#include "G4UIterminal.hh"
-#include "G4UItcsh.hh"
 #include "Randomize.hh"
 
@@ -48,4 +46,8 @@
 #ifdef G4VIS_USE
   #include "G4VisExecutive.hh"
+#endif
+
+#ifdef G4UI_USE
+#include "G4UIExecutive.hh"
 #endif
 
@@ -68,39 +70,14 @@
   runManager->SetUserAction(kin = new PrimaryGeneratorAction(det));
 
-  //visualization manager
-#ifdef G4VIS_USE
-  G4VisManager* visManager = 0;
-#endif
-
   //set user action classes
-  RunAction* run        = new RunAction();
-  EventAction* event    = new EventAction();
-  TrackingAction* track = new TrackingAction();
-  SteppingAction* step  = new SteppingAction();
-
-  runManager->SetUserAction(run);
-  runManager->SetUserAction(event);
-  runManager->SetUserAction(track);
-  runManager->SetUserAction(step);
+  runManager->SetUserAction(new RunAction());
+  runManager->SetUserAction(new EventAction());
+  runManager->SetUserAction(new TrackingAction());
+  runManager->SetUserAction(new SteppingAction());
 
   //get the pointer to the User Interface manager
   G4UImanager* UI = G4UImanager::GetUIpointer();
-
-  if (argc==1)   // Define UI terminal for interactive mode
-    {
-#ifdef G4VIS_USE
-      visManager = new G4VisExecutive;
-      visManager->Initialize();
-#endif
-     G4UIsession* session = 0;
-#ifdef G4UI_USE_TCSH
-      session = new G4UIterminal(new G4UItcsh);
-#else
-      session = new G4UIterminal();
-#endif
-     session->SessionStart();
-     delete session;
-    }
-  else           // Batch mode
+    
+  if (argc!=1)   // batch mode  
     {
      G4String command = "/control/execute ";
@@ -108,9 +85,25 @@
      UI->ApplyCommand(command+fileName);
     }
+    
+  else           //define visualization and UI terminal for interactive mode
+    { 
+#ifdef G4VIS_USE
+   G4VisManager* visManager = new G4VisExecutive;
+   visManager->Initialize();
+#endif    
+     
+#ifdef G4UI_USE
+      G4UIExecutive * ui = new G4UIExecutive(argc,argv);      
+      ui->SessionStart();
+      delete ui;
+#endif
+          
+#ifdef G4VIS_USE
+     delete visManager;
+#endif     
+    }
 
   //job termination
-#ifdef G4VIS_USE
-  if(visManager) delete visManager;
-#endif
+  //
   delete runManager;
 
Index: trunk/examples/extended/electromagnetic/TestEm9/TestEm9.in
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/TestEm9.in	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/TestEm9.in	(revision 1337)
@@ -1,4 +1,4 @@
 # $Id: TestEm9.in,v 1.16 2007/05/17 15:23:04 vnivanch Exp $
-# GEANT4 tag $Name:  $
+# GEANT4 tag $Name: geant4-09-04-beta-01 $
 #
 # Macro file for TestEm9 - Crystal Calorimeter
Index: trunk/examples/extended/electromagnetic/TestEm9/TestEm9.out
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/TestEm9.out	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/TestEm9.out	(revision 1337)
@@ -1,5 +1,9 @@
+
+        ############################################
+        !!! WARNING - FPE detection is activated !!!
+        ############################################
 
 *************************************************************
- Geant4 version Name: global-V09-00-03    (9-May-2008)
+ Geant4 version Name: geant4-09-03-ref-06    (25-June-2010)
                       Copyright : Geant4 Collaboration
                       Reference : NIM A 506 (2003), 250-303
@@ -7,14 +11,8 @@
 *************************************************************
 
-### NIST DataBase for Materials is used
-G4Material: Mean excitation energy is changed for G4_AIR Iold= 85.627eV; Inew= 85.7 eV;
-G4Material: Mean excitation energy is changed for G4_Al Iold= 166.4eV; Inew= 166 eV;
-G4Material: Mean excitation energy is changed for G4_Si Iold= 173.6eV; Inew= 173 eV;
-G4Material: Mean excitation energy is changed for G4_Fe Iold= 286eV; Inew= 286 eV;
-G4Material: Mean excitation energy is changed for G4_CESIUM_IODIDE Iold= 491.166eV; Inew= 553.1 eV;
 /run/verbose 1
 #/tracking/verbose 1
 #
-# select EM PhysicsList
+#  select EM PhysicsList
 #
 /testem/phys/addPhysics emstandard_opt1
@@ -30,206 +28,254 @@
 /testem/det/acceptance25 0.9793 0.00884 2.5
 #
-#/process/eLoss/preciseRange true
-#/process/eLoss/integral true
+#/process/eLoss/preciseRange  true
+#/process/eLoss/integral      true
 /run/initialize
-
-***** Table : Nb of materials = 5 *****
-
- Material:   G4_AIR     density:  1.205 mg/cm3  RadL: 303.921 m    Imean:  85.700 eV   temperature: 273.15 K  pressure:   1.00 atm
-   --->  Element: C (C)   Z =  6.0   N =  12.0   A =  12.01 g/mole
-   --->  Isotope:     C   Z =  6   N =  12   A =  12.00 g/mole   abundance:  98.93 %
-   --->  Isotope:     C   Z =  6   N =  13   A =  13.00 g/mole   abundance:   1.07 %  ElmMassFraction:   0.01 %  ElmAbundance   0.02 %
-   --->  Element: N (N)   Z =  7.0   N =  14.0   A =  14.01 g/mole
-   --->  Isotope:     N   Z =  7   N =  14   A =  14.00 g/mole   abundance:  99.63 %
-   --->  Isotope:     N   Z =  7   N =  15   A =  15.00 g/mole   abundance:   0.37 %  ElmMassFraction:  75.53 %  ElmAbundance  78.44 %
-   --->  Element: O (O)   Z =  8.0   N =  16.0   A =  16.00 g/mole
-   --->  Isotope:     O   Z =  8   N =  16   A =  15.99 g/mole   abundance:  99.76 %
-   --->  Isotope:     O   Z =  8   N =  17   A =  17.00 g/mole   abundance:   0.04 %
-   --->  Isotope:     O   Z =  8   N =  18   A =  18.00 g/mole   abundance:   0.20 %  ElmMassFraction:  23.18 %  ElmAbundance  21.07 %
-   --->  Element: Ar (Ar)   Z = 18.0   N =  40.0   A =  39.95 g/mole
-   --->  Isotope:    Ar   Z = 18   N =  36   A =  35.97 g/mole   abundance:   0.34 %
-   --->  Isotope:    Ar   Z = 18   N =  38   A =  37.96 g/mole   abundance:   0.06 %
-   --->  Isotope:    Ar   Z = 18   N =  40   A =  39.96 g/mole   abundance:  99.60 %  ElmMassFraction:   1.28 %  ElmAbundance   0.47 %
-
- Material:    G4_Al     density:  2.699 g/cm3   RadL:   8.896 cm   Imean: 166.000 eV 
-   --->  Element: Al (Al)   Z = 13.0   N =  27.0   A =  26.98 g/mole
-   --->  Isotope:    Al   Z = 13   N =  27   A =  26.98 g/mole   abundance: 100.00 %  ElmMassFraction: 100.00 %  ElmAbundance 100.00 %
-
- Material:    G4_Si     density:  2.330 g/cm3   RadL:   9.366 cm   Imean: 173.000 eV 
-   --->  Element: Si (Si)   Z = 14.0   N =  28.1   A =  28.09 g/mole
-   --->  Isotope:    Si   Z = 14   N =  28   A =  27.98 g/mole   abundance:  92.23 %
-   --->  Isotope:    Si   Z = 14   N =  29   A =  28.98 g/mole   abundance:   4.68 %
-   --->  Isotope:    Si   Z = 14   N =  30   A =  29.97 g/mole   abundance:   3.09 %  ElmMassFraction: 100.00 %  ElmAbundance 100.00 %
-
- Material:    G4_Fe     density:  7.874 g/cm3   RadL:   1.757 cm   Imean: 286.000 eV 
-   --->  Element: Fe (Fe)   Z = 26.0   N =  55.9   A =  55.85 g/mole
-   --->  Isotope:    Fe   Z = 26   N =  54   A =  53.94 g/mole   abundance:   5.84 %
-   --->  Isotope:    Fe   Z = 26   N =  56   A =  55.93 g/mole   abundance:  91.75 %
-   --->  Isotope:    Fe   Z = 26   N =  57   A =  56.94 g/mole   abundance:   2.12 %
-   --->  Isotope:    Fe   Z = 26   N =  58   A =  57.93 g/mole   abundance:   0.28 %  ElmMassFraction: 100.00 %  ElmAbundance 100.00 %
-
- Material: G4_CESIUM_IODIDE     density:  4.510 g/cm3   RadL:   1.860 cm   Imean: 553.100 eV 
-   --->  Element: I (I)   Z = 53.0   N = 127.0   A = 126.90 g/mole
-   --->  Isotope:     I   Z = 53   N = 127   A = 126.90 g/mole   abundance: 100.00 %  ElmMassFraction:  48.85 %  ElmAbundance  50.00 %
-   --->  Element: Cs (Cs)   Z = 55.0   N = 133.0   A = 132.91 g/mole
-   --->  Isotope:    Cs   Z = 55   N = 133   A = 132.91 g/mole   abundance: 100.00 %  ElmMassFraction:  51.15 %  ElmAbundance  50.00 %
-
-
 Ecal is 36 cm  of G4_CESIUM_IODIDE
 Absorber is 2 mm  of G4_Al
 Vertex is 3 cm  of 3 layers of Si of 100 um  npads= 601
 ### New geometry is constructed
-PhysicsList: world cuts are set cutG= 0.3 mm    cutE= 0.3 mm 
-Vertex cuts are set
-Muon cuts are set
-#
-#/testem/histo/fileName e_pr.root
-#/testem/histo/fileType root
+#
+#/testem/histo/fileName  e_pr.root
+#/testem/histo/fileType  root
 /gun/particle e-
 /gun/energy 1 GeV
 /run/beamOn 100
 
-phot:  Total cross sections from Sandia parametrisation. 
-      Sampling according PhotoElectric model
-
-compt:  Total cross sections has a good parametrisation from 10 KeV to (100/Z) GeV
-      Sampling according Klein-Nishina model
-      tables are built for  gamma
-      Lambda tables from 100 eV  to 100 GeV in 90 bins.
-
-conv:  Total cross sections has a good parametrisation from 1.5 MeV to 100 GeV for all Z;
-      sampling secondary e+e- according Bethe-Heitler model
-      tables are built for  gamma
-      Lambda tables from 1.022 MeV to 100 GeV in 100 bins.
-
-msc:  Model variant of multiple scattering for e-
-      Lambda tables from 100 eV  to 100 TeV in 120 bins.
-      LateralDisplacementFlag=  1   Skin= 0
-      Boundary/stepping algorithm is active with RangeFactor= 0.2  Step limit type 0
-
-eIoni:   tables are built for  e-
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Delta cross sections and sampling from MollerBhabha model
-      Good description from 1 KeV to 100 GeV.
-      Step function: finalRange(mm)= 1, dRoverRange= 0.8, integral: 1, fluct: 1
-
-eBrem:   tables are built for  e-
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Total cross sections and sampling from StandBrem model (based on the EEDL data library) 
-      Good description from 1 KeV to 100 GeV, log scale extrapolation above 100 GeV. LPM flag 1
-
-eIoni:   tables are built for  e+
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Delta cross sections and sampling from MollerBhabha model
-      Good description from 1 KeV to 100 GeV.
-      Step function: finalRange(mm)= 1, dRoverRange= 0.8, integral: 1, fluct: 1
-
-eBrem:   tables are built for  e+
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Total cross sections and sampling from StandBrem model (based on the EEDL data library) 
-      Good description from 1 KeV to 100 GeV, log scale extrapolation above 100 GeV. LPM flag 1
-
-annihil:       Sampling according eplus2gg model
-      tables are built for  e+
-      Lambda tables from 100 eV  to 100 TeV in 120 bins.
-
-msc:  Model variant of multiple scattering for proton
-      Lambda tables from 100 eV  to 100 TeV in 120 bins.
-      LateralDisplacementFlag=  1   Skin= 0
-      Boundary/stepping algorithm is active with RangeFactor= 0.2  Step limit type 0
-
-hIoni:   tables are built for  proton
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Scaling relation is used from proton dE/dx and range.
-      Delta cross sections and sampling from BetheBloch model for scaled energy > 2 MeV
-      Parametrisation from Bragg for protons below. NuclearStopping= 1
-      Step function: finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1
-
-msc:  Model variant of multiple scattering for GenericIon
-      LateralDisplacementFlag=  0   Skin= 0
-      Boundary/stepping algorithm is active with RangeFactor= 0.2  Step limit type 1
-
-ionIoni:   tables are built for  GenericIon
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Scaling relation is used from proton dE/dx and range.
-      Delta cross sections and sampling from BetheBloch model for scaled energy > 2 MeV
-      Parametrisation from BraggIon for protons below. NuclearStopping= 1
-
-      Stopping Power data for 8 ion/material pairs are used.
-      Step function: finalRange(mm)= 0.1, dRoverRange= 0.1, integral: 1, fluct: 1
-
-hIoni:   tables are built for  anti_proton
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Scaling relation is used from proton dE/dx and range.
-      Delta cross sections and sampling from BetheBloch model for scaled energy > 2 MeV
-      Parametrisation from Bragg for protons below. NuclearStopping= 1
-      Step function: finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1
-
-msc:  Model variant of multiple scattering for mu+
-      Lambda tables from 100 eV  to 100 TeV in 120 bins.
-      LateralDisplacementFlag=  1   Skin= 0
-      Boundary/stepping algorithm is active with RangeFactor= 0.2  Step limit type 0
-
-muIoni:   tables are built for  mu+
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Bether-Bloch model for E > 0.2 MeV, parametrisation of Bragg peak below, 
-      radiative corrections for E > 1 GeV
-      Step function: finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1
-
-muBrems:   tables are built for  mu+
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Parametrised model 
-
-muPairProd:   tables are built for  mu+
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Parametrised model 
-
-muIoni:   tables are built for  mu-
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Bether-Bloch model for E > 0.2 MeV, parametrisation of Bragg peak below, 
-      radiative corrections for E > 1 GeV
-      Step function: finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1
-
-muBrems:   tables are built for  mu-
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Parametrised model 
-
-muPairProd:   tables are built for  mu-
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Parametrised model 
-
-hIoni:   tables are built for  pi+
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Scaling relation is used from proton dE/dx and range.
-      Delta cross sections and sampling from BetheBloch model for scaled energy > 0.297504 MeV
-      Parametrisation from Bragg for protons below. NuclearStopping= 1
-      Step function: finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1
-
-msc:  Model variant of multiple scattering for pi-
-      Lambda tables from 100 eV  to 100 TeV in 120 bins.
-      LateralDisplacementFlag=  1   Skin= 0
-      Boundary/stepping algorithm is active with RangeFactor= 0.2  Step limit type 0
-
-hIoni:   tables are built for  pi-
-      dE/dx and range tables from 100 eV  to 100 TeV in 120 bins.
-      Lambda tables from threshold to 100 TeV in 120 bins.
-      Scaling relation is used from proton dE/dx and range.
-      Delta cross sections and sampling from BetheBloch model for scaled energy > 0.297504 MeV
-      Parametrisation from Bragg for protons below. NuclearStopping= 1
-      Step function: finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1
+phot:   for  gamma, applyCuts: 1     SubType= 12
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+       PhotoElectric :     Emin=          0 eV         Emax=   10 TeV
+
+compt:   for  gamma, applyCuts: 1     SubType= 13
+      Lambda tables from 100 eV  to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+       Klein-Nishina :     Emin=          0 eV         Emax=   10 TeV
+
+conv:   for  gamma, applyCuts: 1     SubType= 14
+      Lambda tables from 1.022 MeV to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+       Bethe-Heitler :     Emin=          0 eV         Emax=   10 TeV
+
+msc:   for e-    SubType= 10
+      Lambda tables from 100 eV  to 10 TeV in 77 bins, spline: 1
+      RangeFactor= 0.2, stepLimitType: 0, latDisplacement: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          UrbanMsc93 :     Emin=          0 eV         Emax=   10 TeV
+
+eIoni:   for  e-    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.8, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+        MollerBhabha :     Emin=          0 eV         Emax=   10 TeV
+
+eBrem:   for  e-    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      LPM flag: 1 for E > 1 GeV
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               eBrem :     Emin=          0 eV         Emax=   1 GeV
+            eBremRel :     Emin=          1 GeV        Emax=   10 TeV
+
+eIoni:   for  e+    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.8, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+        MollerBhabha :     Emin=          0 eV         Emax=   10 TeV
+
+eBrem:   for  e+    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      LPM flag: 1 for E > 1 GeV
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               eBrem :     Emin=          0 eV         Emax=   1 GeV
+            eBremRel :     Emin=          1 GeV        Emax=   10 TeV
+
+annihil:   for  e+, applyCuts: 1     SubType= 5
+      Lambda tables from 100 eV  to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+            eplus2gg :     Emin=          0 eV         Emax=   10 TeV
+
+msc:   for proton    SubType= 10
+      Lambda tables from 100 eV  to 10 TeV in 77 bins, spline: 1
+      RangeFactor= 0.2, stepLimitType: 0, latDisplacement: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          UrbanMsc90 :     Emin=          0 eV         Emax=   10 TeV
+
+hIoni:   for  proton    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               Bragg :     Emin=          0 eV         Emax=   2 MeV
+          BetheBloch :     Emin=          2 MeV        Emax=   10 TeV
+
+hBrems:   for  proton    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               hBrem :     Emin=          0 eV         Emax=   10 TeV
+
+hPairProd:   for  proton    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+           hPairProd :     Emin=          0 eV         Emax=   10 TeV
+
+msc:   for GenericIon    SubType= 10
+      RangeFactor= 0.2, stepLimitType: 0, latDisplacement: 0
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          UrbanMsc90 :     Emin=          0 eV         Emax=   10 TeV
+
+ionIoni:   for  GenericIon    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 0.1, dRoverRange= 0.1, integral: 1, fluct: 1, linLossLimit= 0.02
+      Stopping Power data for 17 ion/material pairs, nuclearStopping: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+            BraggIon :     Emin=          0 eV         Emax=   2 MeV
+          BetheBloch :     Emin=          2 MeV        Emax=   10 TeV
+
+hIoni:   for  anti_proton    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+            ICRU73QO :     Emin=          0 eV         Emax=   2 MeV
+          BetheBloch :     Emin=          2 MeV        Emax=   10 TeV
+
+hIoni:   for  kaon+    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               Bragg :     Emin=          0 eV         Emax=   1.05231 MeV
+          BetheBloch :     Emin=    1.05231 MeV        Emax=   10 TeV
+
+hBrems:   for  kaon+    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               hBrem :     Emin=          0 eV         Emax=   10 TeV
+
+hPairProd:   for  kaon+    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+           hPairProd :     Emin=          0 eV         Emax=   10 TeV
+
+hIoni:   for  kaon-    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+            ICRU73QO :     Emin=          0 eV         Emax=   1.05231 MeV
+          BetheBloch :     Emin=    1.05231 MeV        Emax=   10 TeV
+
+hBrems:   for  kaon-    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               hBrem :     Emin=          0 eV         Emax=   10 TeV
+
+hPairProd:   for  kaon-    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+           hPairProd :     Emin=          0 eV         Emax=   10 TeV
+
+muMsc:   for mu+    SubType= 10
+      Lambda tables from 100 eV  to 10 TeV in 77 bins, spline: 1
+      RangeFactor= 0.2, step limit type: 0, lateralDisplacement: 1, polarAngleLimit(deg)= 0
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          UrbanMsc90 :     Emin=          0 eV         Emax=   10 TeV
+
+muIoni:   for  mu+    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               Bragg :     Emin=          0 eV         Emax=   200 keV
+          BetheBloch :     Emin=        200 keV        Emax=   1 GeV
+        MuBetheBloch :     Emin=          1 GeV        Emax=   10 TeV
+
+muBrems:   for  mu+    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+              MuBrem :     Emin=          0 eV         Emax=   10 TeV
+
+muPairProd:   for  mu+    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          muPairProd :     Emin=          0 eV         Emax=   10 TeV
+
+muIoni:   for  mu-    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+            ICRU73QO :     Emin=          0 eV         Emax=   200 keV
+          BetheBloch :     Emin=        200 keV        Emax=   1 GeV
+        MuBetheBloch :     Emin=          1 GeV        Emax=   10 TeV
+
+muBrems:   for  mu-    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+              MuBrem :     Emin=          0 eV         Emax=   10 TeV
+
+muPairProd:   for  mu-    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          muPairProd :     Emin=          0 eV         Emax=   10 TeV
+
+hIoni:   for  pi+    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               Bragg :     Emin=          0 eV         Emax=   297.504 keV
+          BetheBloch :     Emin=    297.504 keV        Emax=   10 TeV
+
+hBrems:   for  pi+    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               hBrem :     Emin=          0 eV         Emax=   10 TeV
+
+hPairProd:   for  pi+    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+           hPairProd :     Emin=          0 eV         Emax=   10 TeV
+
+msc:   for pi-    SubType= 10
+      Lambda tables from 100 eV  to 10 TeV in 77 bins, spline: 1
+      RangeFactor= 0.2, stepLimitType: 0, latDisplacement: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+          UrbanMsc90 :     Emin=          0 eV         Emax=   10 TeV
+
+hIoni:   for  pi-    SubType= 2
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      finalRange(mm)= 1, dRoverRange= 0.2, integral: 1, fluct: 1, linLossLimit= 0.01
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+            ICRU73QO :     Emin=          0 eV         Emax=   297.504 keV
+          BetheBloch :     Emin=    297.504 keV        Emax=   10 TeV
+
+hBrems:   for  pi-    SubType= 3
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+               hBrem :     Emin=          0 eV         Emax=   10 TeV
+
+hPairProd:   for  pi-    SubType= 4
+      dE/dx and range tables from 100 eV  to 10 TeV in 77 bins
+      Lambda tables from threshold to 10 TeV in 77 bins, spline: 1
+      ===== EM models for the G4Region  DefaultRegionForTheWorld ======
+           hPairProd :     Emin=          0 eV         Emax=   10 TeV
 
 ========= Table of registered couples ==============================
@@ -237,6 +283,6 @@
 Index : 0     used in the geometry : Yes     recalculation needed : No 
  Material : G4_AIR
- Range cuts        :  gamma 300 um     e- 300 um     e+ 300 um 
- Energy thresholds :  gamma 990 eV     e- 990 eV     e+ 990 eV 
+ Range cuts        :  gamma  300 um     e-  300 um     e+  300 um  proton 0 fm 
+ Energy thresholds :  gamma  990 eV     e-  990 eV     e+  990 eV  proton 0 eV 
  Region(s) which use this couple : 
     DefaultRegionForTheWorld
@@ -244,6 +290,6 @@
 Index : 1     used in the geometry : Yes     recalculation needed : No 
  Material : G4_CESIUM_IODIDE
- Range cuts        :  gamma 300 um     e- 300 um     e+ 300 um 
- Energy thresholds :  gamma 18.1187 keV    e- 288.607 keV    e+ 278.143 keV
+ Range cuts        :  gamma  300 um     e-  300 um     e+  300 um  proton 0 fm 
+ Energy thresholds :  gamma  18.2919 keV    e-  291.524 keV    e+  281.891 keV proton 0 eV 
  Region(s) which use this couple : 
     DefaultRegionForTheWorld
@@ -251,6 +297,6 @@
 Index : 2     used in the geometry : Yes     recalculation needed : No 
  Material : G4_Al
- Range cuts        :  gamma 300 um     e- 300 um     e+ 300 um 
- Energy thresholds :  gamma 3.89739 keV    e- 258.339 keV    e+ 252.056 keV
+ Range cuts        :  gamma  300 um     e-  300 um     e+  300 um  proton 0 fm 
+ Energy thresholds :  gamma  3.92577 keV    e-  258.31 keV    e+  253.154 keV proton 0 eV 
  Region(s) which use this couple : 
     DefaultRegionForTheWorld
@@ -258,6 +304,6 @@
 Index : 3     used in the geometry : Yes     recalculation needed : No 
  Material : G4_AIR
- Range cuts        :  gamma 10 um     e- 10 um     e+ 10 um 
- Energy thresholds :  gamma 990 eV     e- 990 eV     e+ 990 eV 
+ Range cuts        :  gamma  10 um     e-  10 um     e+  10 um  proton 0 fm 
+ Energy thresholds :  gamma  990 eV     e-  990 eV     e+  990 eV  proton 0 eV 
  Region(s) which use this couple : 
     VertexDetector
@@ -265,6 +311,6 @@
 Index : 4     used in the geometry : Yes     recalculation needed : No 
  Material : G4_Al
- Range cuts        :  gamma 10 um     e- 10 um     e+ 10 um 
- Energy thresholds :  gamma 990 eV     e- 33.8876 keV    e+ 33.4729 keV
+ Range cuts        :  gamma  10 um     e-  10 um     e+  10 um  proton 0 fm 
+ Energy thresholds :  gamma  990 eV     e-  34.1725 keV    e+  33.9436 keV proton 0 eV 
  Region(s) which use this couple : 
     VertexDetector
@@ -272,6 +318,6 @@
 Index : 5     used in the geometry : Yes     recalculation needed : No 
  Material : G4_Si
- Range cuts        :  gamma 10 um     e- 10 um     e+ 10 um 
- Energy thresholds :  gamma 990 eV     e- 31.4747 keV    e+ 31.0896 keV
+ Range cuts        :  gamma  10 um     e-  10 um     e+  10 um  proton 0 fm 
+ Energy thresholds :  gamma  990 eV     e-  31.9516 keV    e+  31.7376 keV proton 0 eV 
  Region(s) which use this couple : 
     VertexDetector
@@ -279,6 +325,6 @@
 Index : 6     used in the geometry : Yes     recalculation needed : No 
  Material : G4_Fe
- Range cuts        :  gamma 1 cm     e- 1 cm     e+ 1 cm 
- Energy thresholds :  gamma 60.4019 keV    e- 12.9518 MeV    e+ 12.0297 MeV
+ Range cuts        :  gamma  1 cm     e-  1 cm     e+  1 cm  proton 0 fm 
+ Energy thresholds :  gamma  60.499 keV    e-  13.0779 MeV    e+  12.2279 MeV proton 0 eV 
  Region(s) which use this couple : 
     MuonDetector
@@ -286,6 +332,6 @@
 Index : 7     used in the geometry : Yes     recalculation needed : No 
  Material : G4_Al
- Range cuts        :  gamma 1 cm     e- 1 cm     e+ 1 cm 
- Energy thresholds :  gamma 20.4949 keV    e- 4.54874 MeV    e+ 4.2772 MeV
+ Range cuts        :  gamma  1 cm     e-  1 cm     e+  1 cm  proton 0 fm 
+ Energy thresholds :  gamma  20.3682 keV    e-  4.52289 MeV    e+  4.28616 MeV proton 0 eV 
  Region(s) which use this couple : 
     MuonDetector
@@ -299,32 +345,42 @@
 Run Summary
   Number of events processed : 100
-  User=4.19s Real=4.21s Sys=0s
+  User=1.85s Real=2.86s Sys=0s
 RunAction: End of run actions are started
 HistoManager: End of run actions are started
 =================================================================
 Number of events             100
-Average number of e-         1320
-Average number of gamma      701.3
-Average number of e+         48.12
-Average number of steps      3980
-Edep 1x1 =                   0.8336 +- 0.002518  res=  3.021 %
-Edep 3x3 =                   0.9601 +- 0.001163  res=  1.212 %
-Edep 5x5 =                   0.9807 +- 0.0007853  res=  0.8007 %
+Average number of e-         404.1
+Average number of gamma      680.3
+Average number of e+         48.44
+Average number of steps      3032
+Edep 1x1 =                   0.8268 +- 0.003033  res=  3.576 %
+Edep 3x3 =                   0.9564 +- 0.00132  res=  1.36 %
+Edep 5x5 =                   0.98 +- 0.0007972  res=  0.8052 %
 ===========  Mean values without trancating =====================
-Edep 1x1 =                   0.8327 +- 0.002681  res=  3.219 %
-Edep 3x3 =                   0.9596 +- 0.001241  res=  1.293 %
-Edep 5x5 =                   0.9807 +- 0.0007853  res=  0.8007 %
+Edep 1x1 =                   0.8215 +- 0.003784  res=  4.607 %
+Edep 3x3 =                   0.9552 +- 0.001452  res=  1.52 %
+Edep 5x5 =                   0.9793 +- 0.0009604  res=  0.9807 %
+===========  Ratios without trancating ===========================
+  E1/E9  =                   0.8599 +- 0.003448
+  E1/E25 =                   0.8388 +- 0.003691
+  E9/E25 =                   0.9754 +- 0.001015
+Beam Energy                  1 GeV
 ==================================================================
 
 
 <<<<<ACCEPTANCE>>>>> 100 events for Crystal Calorimeter
-Edep1x1: 0.8336  delEdep1x1= 0.006515 nrms= 2.191
-Erms1x1: 0.02518  delErms1x1= -0.00456 nrms= -1.533
-Edep3x3: 0.9601  delEdep3x3= 0.003087 nrms= 2.401
-Erms3x3: 0.01163  delErms3x3= -0.001226 nrms= -0.9531
-Edep5x5: 0.9807  delEdep5x5= 0.001428 nrms= 1.615
-Erms5x5: 0.007853  delErms5x5= -0.0009872 nrms= -1.117
+Edep1x1: 0.8268  delEdep1x1= -0.0003204 nrms= -0.1077
+Erms1x1: 0.02957  delErms1x1= -0.0001739 nrms= -0.05847
+Edep3x3: 0.9564  delEdep3x3= -0.0006442 nrms= -0.5009
+Erms3x3: 0.01301  delErms3x3= 0.0001451 nrms= 0.1128
+Edep5x5: 0.98  delEdep5x5= 0.0007303 nrms= 0.8261
+Erms5x5: 0.007892  delErms5x5= -0.0009484 nrms= -1.073
 <<<<<END>>>>>   IS ACCEPTED
 
+   Z  bremsstrahlung photoeffect  compton    conversion
+  13           0           0         158           0
+  53         284          41           0          45
+  55         298          48           0          49
 #
 G4 kernel has come to Quit state.
+
Index: trunk/examples/extended/electromagnetic/TestEm9/csi.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/csi.mac	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/csi.mac	(revision 1337)
@@ -1,4 +1,4 @@
 # $Id: csi.mac,v 1.4 2006/10/26 15:50:35 maire Exp $
-# GEANT4 tag $Name: geant4-09-03-cand-01 $
+# GEANT4 tag $Name: geant4-09-04-beta-01 $
 #
 # Macro file for TestEm9 - Crystal Calorimeter
Index: trunk/examples/extended/electromagnetic/TestEm9/include/DetectorConstruction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/DetectorConstruction.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/DetectorConstruction.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: DetectorConstruction.hh,v 1.7 2008/04/07 18:09:05 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/include/DetectorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/DetectorMessenger.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/DetectorMessenger.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: DetectorMessenger.hh,v 1.4 2006/06/29 17:00:58 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/include/EmAcceptance.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/EmAcceptance.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/EmAcceptance.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: EmAcceptance.hh,v 1.2 2006/06/29 17:01:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/include/EventAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/EventAction.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/EventAction.hh	(revision 1337)
@@ -28,5 +28,5 @@
 
 // $Id: EventAction.hh,v 1.3 2006/06/29 17:01:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
Index: trunk/examples/extended/electromagnetic/TestEm9/include/EventActionMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/EventActionMessenger.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/EventActionMessenger.hh	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.hh,v 1.3 2006/06/29 17:01:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/include/Histo.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/Histo.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/Histo.hh	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: Histo.hh,v 1.5 2007/05/24 13:17:41 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 
 #ifndef Histo_h
Index: trunk/examples/extended/electromagnetic/TestEm9/include/HistoManager.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/HistoManager.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/HistoManager.hh	(revision 1337)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.hh,v 1.11 2008/09/24 10:38:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: HistoManager.hh,v 1.12 2010/04/29 15:21:39 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 
 #ifndef HistoManager_h
@@ -54,5 +54,4 @@
 #include "G4DataVector.hh"
 #include "G4Track.hh"
-//#include "Histo.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -150,4 +149,8 @@
   G4DataVector Evertex;
   G4DataVector Nvertex;
+  G4DataVector brem;
+  G4DataVector phot;
+  G4DataVector comp;
+  G4DataVector conv;
 
   G4double  edeptrue[3];
Index: trunk/examples/extended/electromagnetic/TestEm9/include/HistoMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/HistoMessenger.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/HistoMessenger.hh	(revision 1337)
@@ -27,5 +27,5 @@
 //
 // $Id: HistoMessenger.hh,v 1.3 2006/06/29 17:01:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/include/PhysListEmStandard.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/PhysListEmStandard.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/PhysListEmStandard.hh	(revision 1337)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: PhysListEmStandard.hh,v 1.3 2006/06/29 17:02:17 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: PhysListEmStandard.hh,v 1.5 2009/11/20 20:25:40 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/include/PhysicsList.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/PhysicsList.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/PhysicsList.hh	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsList.hh,v 1.7 2008/04/07 18:09:05 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/include/PhysicsListMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/PhysicsListMessenger.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/PhysicsListMessenger.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysicsListMessenger.hh,v 1.4 2006/06/29 17:02:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // 
Index: trunk/examples/extended/electromagnetic/TestEm9/include/PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/PrimaryGeneratorAction.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/PrimaryGeneratorAction.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: PrimaryGeneratorAction.hh,v 1.3 2006/06/29 17:02:35 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/include/StepMax.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/StepMax.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/StepMax.hh	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.hh,v 1.3 2006/06/29 17:02:40 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/include/StepMaxMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/StepMaxMessenger.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/StepMaxMessenger.hh	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.hh,v 1.3 2006/06/29 17:02:42 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/include/SteppingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/include/SteppingAction.hh	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/include/SteppingAction.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: SteppingAction.hh,v 1.3 2006/06/29 17:02:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/DetectorConstruction.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/DetectorConstruction.cc	(revision 1337)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: DetectorConstruction.cc,v 1.11 2008/04/07 18:09:05 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: DetectorConstruction.cc,v 1.14 2009/11/21 17:28:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
@@ -251,7 +251,10 @@
   G4double vertWidth = ecalWidth/5.;
   G4int npads = (G4int)(vertWidth/padWidth);
+  //G4cout << " vertWidth= " << vertWidth << " padWidth= " << padWidth 
+  //	 << " npads= " << npads << G4endl;
+  // insure beam to hit a middle of central pad
   npads = (npads/2)*2 + 1;
-  x0 = -0.5*padWidth*((G4double)(npads-1));
-  G4double x1 = std::fabs(x0) + 0.5*padWidth + gap; 
+  x0 = -0.5*(padWidth + vertWidth);
+  G4double x1 = 0.5*vertWidth + gap; 
   G4double z  = -(vertexLength+absLength);
 
Index: trunk/examples/extended/electromagnetic/TestEm9/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/DetectorMessenger.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/DetectorMessenger.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.3 2006/06/29 17:03:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/src/EmAcceptance.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/EmAcceptance.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/EmAcceptance.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: EmAcceptance.cc,v 1.4 2006/06/29 17:03:03 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/src/EventAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/EventAction.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/EventAction.cc	(revision 1337)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: EventAction.cc,v 1.4 2006/06/29 17:03:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: EventAction.cc,v 1.6 2010/06/07 05:40:46 perl Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -35,7 +35,4 @@
 
 #include "G4UImanager.hh"
-#include "G4TrajectoryContainer.hh"
-#include "G4Trajectory.hh"
-#include "G4VVisManager.hh"
 #include "G4Gamma.hh"
 #include "G4ios.hh"
@@ -92,21 +89,7 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-void EventAction::EndOfEventAction(const G4Event* evt)
+void EventAction::EndOfEventAction(const G4Event*)
 {
   (HistoManager::GetPointer())->EndOfEvent();
-  G4VVisManager* pVVisManager = G4VVisManager::GetConcreteInstance();
-
-  if(pVVisManager) {
-    G4TrajectoryContainer* trjc = evt->GetTrajectoryContainer();
-    G4int n_trajectories = 0;
-    if (trjc) n_trajectories = trjc->entries();
-
-    for(G4int i=0; i<n_trajectories; i++) {
-      G4Trajectory* t = (G4Trajectory*)((*(evt->GetTrajectoryContainer()))[i]);
-      if (drawFlag == "all") t->DrawTrajectory(1000);
-      else if ((drawFlag == "charged")&&(t->GetCharge() != 0.))
-                             t->DrawTrajectory(1000);
-    }
-  }
 
   if(verbose > 0) {
Index: trunk/examples/extended/electromagnetic/TestEm9/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/EventActionMessenger.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/EventActionMessenger.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.3 2006/06/29 17:03:08 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/HistoManager.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/HistoManager.cc	(revision 1337)
@@ -38,4 +38,9 @@
 
 #include "HistoManager.hh"
+#include "G4MaterialCutsCouple.hh"
+#include "G4EmProcessSubType.hh"
+#include "G4VProcess.hh"
+#include "G4VEmProcess.hh"
+#include "G4VEnergyLossProcess.hh"
 #include "G4UnitsTable.hh"
 #include "Histo.hh"
@@ -163,4 +168,9 @@
 
   histo->book();
+
+  brem.resize(93,0.0);
+  phot.resize(93,0.0);
+  comp.resize(93,0.0);
+  conv.resize(93,0.0);
 
   if(verbose > 0) {
@@ -280,4 +290,17 @@
   }
   if(isStarted) acc.EndOfAcceptance();
+
+  // atom frequency
+  G4cout << "   Z  bremsstrahlung photoeffect  compton    conversion" << G4endl;
+  for(j=1; j<93; ++j) {
+    G4int n1 = G4int(brem[j]*x);
+    G4int n2 = G4int(phot[j]*x);
+    G4int n3 = G4int(comp[j]*x);
+    G4int n4 = G4int(conv[j]*x);
+    if(n1 + n2 + n3 + n4 > 0) {
+      G4cout << std::setw(4) << j << std::setw(12) << n1 << std::setw(12) << n2
+	     << std::setw(12) << n3 << std::setw(12) << n4 << G4endl;
+    }
+  }
 }
 
@@ -390,4 +413,5 @@
   G4ThreeVector pos = aTrack->GetVertexPosition();
 
+  // primary
   if(0 == pid) {
 
@@ -414,24 +438,54 @@
     }
 
+    // secondary
+  } else {
+    const G4VProcess* proc = aTrack->GetCreatorProcess();
+    G4int type = proc->GetProcessSubType();
+    if(type == fBremsstrahlung) {
+      const G4Element* elm = static_cast<const G4VEnergyLossProcess*>(proc)->GetCurrentElement();
+      if(elm) {
+	G4int Z = G4int(elm->GetZ());
+        if(Z > 0 && Z < 93) { brem[Z] += 1.0; }
+      }
+    } else if(type == fPhotoElectricEffect) {
+      const G4Element* elm = static_cast<const G4VEmProcess*>(proc)->GetCurrentElement();
+      if(elm) {
+	G4int Z = G4int(elm->GetZ());
+        if(Z > 0 && Z < 93) { phot[Z] += 1.0; }
+      }
+    } else if(type == fGammaConversion) {
+      const G4Element* elm = static_cast<const G4VEmProcess*>(proc)->GetCurrentElement();
+      if(elm) {
+	G4int Z = G4int(elm->GetZ());
+        if(Z > 0 && Z < 93) { conv[Z] += 1.0; }
+      }
+    } else if(type == fComptonScattering) {
+      const G4Element* elm = static_cast<const G4VEmProcess*>(proc)->GetCurrentElement();
+      if(elm) {
+	G4int Z = G4int(elm->GetZ());
+        if(Z > 0 && Z < 93) { comp[Z] += 1.0; }
+      }
+    }
+
     // delta-electron
-  } else if (0 < pid && "e-" == name) {
-    if(1 < verbose) {
-      G4cout << "TrackingAction: Secondary electron " << G4endl;
-    }
-    AddDeltaElectron(dynParticle);
-
-  } else if (0 < pid && "e+" == name) {
-    if(1 < verbose) {
-      G4cout << "TrackingAction: Secondary positron " << G4endl;
-    }
-    AddPositron(dynParticle);
-
-  } else if (0 < pid && "gamma" == name) {
-    if(1 < verbose) {
-      G4cout << "TrackingAction: Secondary gamma; parentID= " << pid
-             << " E= " << kinE << G4endl;
-    }
-    AddPhoton(dynParticle);
-
+    if (0 < pid && "e-" == name) {
+      if(1 < verbose) {
+	G4cout << "TrackingAction: Secondary electron " << G4endl;
+      }
+      AddDeltaElectron(dynParticle);
+
+    } else if (0 < pid && "e+" == name) {
+      if(1 < verbose) {
+	G4cout << "TrackingAction: Secondary positron " << G4endl;
+      }
+      AddPositron(dynParticle);
+
+    } else if (0 < pid && "gamma" == name) {
+      if(1 < verbose) {
+	G4cout << "TrackingAction: Secondary gamma; parentID= " << pid
+	       << " E= " << kinE << G4endl;
+      }
+      AddPhoton(dynParticle);
+    }
   }
 }
Index: trunk/examples/extended/electromagnetic/TestEm9/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/HistoMessenger.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/HistoMessenger.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: HistoMessenger.cc,v 1.7 2008/08/22 14:11:53 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/src/PhysListEmStandard.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/PhysListEmStandard.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/PhysListEmStandard.cc	(revision 1337)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: PhysListEmStandard.cc,v 1.13 2008/11/16 21:01:10 maire Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: PhysListEmStandard.cc,v 1.15 2009/11/20 20:27:21 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/src/PhysicsList.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/PhysicsList.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/PhysicsList.cc	(revision 1337)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysicsList.cc,v 1.24 2008/10/16 11:48:58 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: PhysicsList.cc,v 1.25 2009/11/20 20:22:44 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //---------------------------------------------------------------------------
@@ -50,6 +50,6 @@
 #include "G4EmStandardPhysics_option2.hh"
 #include "G4EmStandardPhysics_option3.hh"
-#include "PhysListEmLivermore.hh"
-#include "PhysListEmPenelope.hh"
+#include "G4EmLivermorePhysics.hh"
+#include "G4EmPenelopePhysics.hh"
 #include "G4DecayPhysics.hh"
 #include "G4HadronElasticPhysics.hh"
@@ -188,17 +188,13 @@
       G4cout << "PhysicsList::Set " << name << " EM physics" << G4endl;
 
-  } else if (name == "livermore") {
-    emName = name;
-    delete emPhysicsList;
-    emPhysicsList = new PhysListEmLivermore();
-    if (verboseLevel > 0) 
-      G4cout << "PhysicsList::Set Livermore EM physics" << G4endl;
-
-  } else if (name == "penelope") {
-    emName = name;
-    delete emPhysicsList;
-    emPhysicsList = new PhysListEmPenelope();
-    if (verboseLevel > 0) 
-      G4cout << "PhysicsList::Set Penelope EM physics" << G4endl;
+  } else if (name == "emlivermore") {
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmLivermorePhysics();
+
+  } else if (name == "empenelope") {
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmPenelopePhysics();
 
   } else if (name == "elastic" && !helIsRegisted) {
Index: trunk/examples/extended/electromagnetic/TestEm9/src/PhysicsListMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/PhysicsListMessenger.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/PhysicsListMessenger.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysicsListMessenger.cc,v 1.4 2008/04/03 15:07:55 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // 
Index: trunk/examples/extended/electromagnetic/TestEm9/src/PrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/PrimaryGeneratorAction.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/PrimaryGeneratorAction.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: PrimaryGeneratorAction.cc,v 1.3 2006/06/29 17:03:46 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/src/StepMax.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/StepMax.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/StepMax.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.cc,v 1.3 2006/06/29 17:03:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/src/StepMaxMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/StepMaxMessenger.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/StepMaxMessenger.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.cc,v 1.2 2006/06/29 17:03:54 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm9/src/SteppingAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/src/SteppingAction.cc	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/src/SteppingAction.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: SteppingAction.cc,v 1.2 2006/06/29 17:03:57 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/examples/extended/electromagnetic/TestEm9/vis.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm9/vis.mac	(revision 1230)
+++ trunk/examples/extended/electromagnetic/TestEm9/vis.mac	(revision 1337)
@@ -10,26 +10,70 @@
 /run/initialize
 #
-# Create empty scene ("world" is default)
-/vis/scene/create
+# Use this open statement to create an OpenGL view:
+/vis/open OGL 600x600-0+0
 #
-# Create a scene handler for a specific graphics system
-# Edit the next line(s) to choose another graphic system
-#
-/vis/open OGLIX
-#/vis/open OGLIXm
-#
+# Use this open statement to create a .prim file suitable for
+# viewing in DAWN:
 #/vis/open DAWNFILE
 #
-# Draw scene
-/vis/viewer/set/viewpointThetaPhi 90 0 deg
+# Use this open statement to create a .heprep file suitable for
+# viewing in HepRApp:
+#/vis/open HepRepFile
+#
+# Use this open statement to create a .wrl file suitable for
+# viewing in a VRML viewer:
+#/vis/open VRML2FILE
+#
+# Disable auto refresh and quieten vis messages whilst scene and
+# trajectories are established:
+/vis/viewer/set/autoRefresh false
+/vis/verbose errors
+#
+# Draw geometry:
+/vis/drawVolume
+#
+# Specify view angle:
+/vis/viewer/set/viewpointThetaPhi 90. 0.
+#
+# Specify zoom value:
 /vis/viewer/zoom 1.4
-/vis/viewer/flush
 #
-# for drawing the tracks
-# if too many tracks cause core dump => storeTrajectory 0
-/tracking/storeTrajectory 1
+# Specify style (surface or wireframe):
+#/vis/viewer/set/style wireframe
+#
+# Draw coordinate axes:
+#/vis/scene/add/axes 0 0 0 1 m
+#
+# Draw smooth trajectories at end of event, showing trajectory points
+# as markers 2 pixels wide:
+/vis/scene/add/trajectories smooth
+/vis/modeling/trajectories/create/drawByCharge
+/vis/modeling/trajectories/drawByCharge-0/default/setDrawStepPts true
+/vis/modeling/trajectories/drawByCharge-0/default/setStepPtsSize 1
+# (if too many tracks cause core dump => /tracking/storeTrajectory 0)
+#
+# Draw hits at end of event:
+#/vis/scene/add/hits
+#
+# To draw only gammas:
+/vis/filtering/trajectories/create/particleFilter
+/vis/filtering/trajectories/particleFilter-0/add gamma
+#
+# To invert the above, drawing all particles except gammas,
+# keep the above two lines but also add:
+/vis/filtering/trajectories/particleFilter-0/invert true
+#
+# Many other options are available with /vis/modeling and /vis/filtering.
+# For example, to select colour by particle ID:
+#/vis/modeling/trajectories/create/drawByParticleID
+#/vis/modeling/trajectories/drawByParticleID-0/set e- blue
+#
+# To superimpose all of the events from a given run:
 /vis/scene/endOfEventAction accumulate
 #
-#/testem/event/drawTracks all
-/testem/event/drawTracks charged
-
+# Re-establish auto refreshing and verbosity:
+/vis/viewer/set/autoRefresh true
+/vis/verbose warnings
+#
+# For file-based drivers, use this to create an empty detector view:
+#/vis/viewer/flush
